var tweetLimit = 140;
var $textarea = $('textarea');
var $tweetCounter = $('.tweet_counter');
var $tweetbox = $('.tweetbox');
var remainingCharacters = tweetLimit;

var calculateRemainingCharacters = function () {
  remainingCharacters = tweetLimit - $textarea.val().length;

  $tweetCounter.text(remainingCharacters)

  if (remainingCharacters < 15) {
    $tweetCounter.css({color: 'red'});
  } else {
    $tweetCounter.css({color: 'inherit'});
  }
};

var handleData = function (dataReceived) {
  var $newTweet = $('.tweet').last().clone().hide();

  $newTweet.find('.tweet_content').text(dataReceived.tweet_content);
  $newTweet.find('.author').text(dataReceived.tweet_author);
  $newTweet.find('img').attr('src', dataReceived.tweet_avatar);
  $newTweet.find('.time').text('now');

  $newTweet.prependTo('.tweets').slideDown();
};

$tweetCounter.text(remainingCharacters);

$textarea.on('keydown', function (event) {
  if (event.which !== 8 && remainingCharacters === 0) {
    event.preventDefault();
  }
});

$textarea.on('keyup', function (event) {
  console.log('key ' + event.which + ' was pressed.');

  calculateRemainingCharacters();
});

$tweetbox.on('submit', function (event) {
  event.preventDefault();

  $.ajax({
    url: $tweetbox.attr('action'),
    type: $tweetbox.attr('method'),
    dataType: 'json',
    data: $tweetbox.serialize()
  }).done(function (data) {
    handleData(data);

    // only clear textarea and calculate characters if
    // form was submitted. Handle data here and below, regardless.
    $textarea.val('');
    calculateRemainingCharacters();
  });
});

// attach a listener to the document - it will listen for any
// clicks on ".buttons button"s regardless of whether they
// exist at the time of listener attachment.
$(document).on('click', '.buttons button', function (event) {
  var $button = $(this);
  var buttonClass = $button.attr('class');
  var $tweet = $button.closest('.tweet');

  if (buttonClass === 'favorite') {
    $tweet.toggleClass('favorited');
  } else if (buttonClass === 'retweet') {
    $tweet.toggleClass('retweeted');
  }
});

setInterval(function () {
  $.ajax({
    url: 'tweet.php',
    type: 'get',
    dataType: 'json'
  }).done(handleData);
}, 10000);


